package cn.chnmuseum.party.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * @description:
 * @author: nh
 * @create: 2021-05-25 23:12
 **/
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@TableName("t_video_visitor")
@ApiModel(value = "视频播放者的地区", description = "视频播放者的地区")
public class TVideoVisitor implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id", name = "id")
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty(value = "videoId", name = "视频id")
    @TableField("video_id")
    private String videoId;

    @ApiModelProperty(value = "area", name = "地区")
    @TableField("area")
    private String area;

    @ApiModelProperty(value = "area", name = "地区编码")
    @TableField("area_code")
    private String areaCode;

    @ApiModelProperty(value = "userIp", name = "用户ip")
    @TableField("user_ip")
    private String userIp;

    @ApiModelProperty(value = "createTime", name = "创建时间")
    @TableField("create_time")
    private Date createTime;

    @ApiModelProperty(value = "updateTime", name = "更新时间")
    @TableField("update_time")
    private Date updateTime;
}
